/*
** Der umstlpbare Wrfel nach Paul Schatz
** Copyright (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
*/
#ifndef OS_WIN32
#include <config.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <GL/glut.h>
#include <GL/gl.h>

#define CHECKOGLERR
#include "wuerfel.h"

void
wKey (unsigned char key, int x, int y) {

/*   static int gkf = 0; */
/*   fprintf (stderr, "glutKeyboardFunc %d\n", ++gkf); */

    switch (key) {
    case 27: /* ESC */
    case 'q':
	wExit ();
	break;
    case '1':
    case '2':
    case '3':
    case '4':
	wSubMenuModus ((int)(key - '0'));
        break;
    case ' ':
        wSetImpulse ();
        break;
    case '.':
	wNextPos ();
	break;
    case ',':
	wPrevPos ();
	break;
    case 'a':
	wToggleAxis ();
	break;
    case 'A':
	wToggleAutomatic ();
	break;
    case 'b':
	wToggleTouchline ();
	break;
    case 'B':
	wToggleBeide ();
	break;
    case 'c':
	wAdvanceAxisTransform ();
	break;
    case 'D':
	wToggleDiagonals ();
	break;
    case 'e':
	wToggleEndpunkte ();
	break;
    case 'g':
	wToggleGitterFlaechen ();
	break;
    case 'i':
        wToggleInfo ();
	break;
    case 'k':
        wToggleKuboid ();
	break;
    case 'l':
        wToggleLabels ();
	break;
    case 'M':
	wToggleCenter ();
	break;
    case 'o':
        wToggleOloid ();
	break;
    case 'p':
	wTogglePerspektive ();
	break;
    case 'r':
	wToggleErzeugende ();
	break;
    case 's':
	wToggleHalt ();
	break;
    case 't':
	wToggleTorkeln ();
	break;
    case 'v':
	wToggleVirtuell ();
	break;
    case 'w':
        wToggleWuerfelguertel ();
	break;
    case 'x':
	rotx += 1.;
	wThisPos ();
	break;
    case 'y':
	roty += 1.;
	wThisPos ();
	break;
    case 'z':
	rotz += 1.;
	wThisPos ();
	break;
    case 'X':
	rotx -= 1.;
	wThisPos ();
	break;
    case 'Y':
	roty -= 1.;
	wThisPos ();
	break;
    case 'Z':
	rotz -= 1.;
	wThisPos ();
	break;
    case '+':
	wSubMenuSpeed (1);
	break;
    case '-':
	wSubMenuSpeed (2);
	break;
    default:
	return;
    }
    
    /* wenn sich was an den Optionen aendert, diese erneut anzeigen */
    switch (key) {
    case '1':
    case '2':
    case '3':
/*     case '4': */
    case 'a':
    case 'A':
    case 'b':
    case 'c':
    case 'D':
    case 'e':
    case 'g':
    case 'i':
    case 'k':
    case 'l':
    case 'M':
    case 'o':
    case 'p':
    case 'r':
    case 't':
    case 'v':
    case 'w':
    case '+':
    case '-':
        wDisplayOptions ();
	break;
    default:
	return;
    }
    wPostRedisplay ();
}

void
wSpecialKey (int key, int x, int y) {

/*   static int gsf = 0; */
/*   fprintf (stderr, "glutSpecialFunc %d\n", ++gsf); */

    switch (key) {
    case GLUT_KEY_UP:
	trany += 0.1;
	break;
    case GLUT_KEY_DOWN:
	trany -= 0.1;
	break;
    case GLUT_KEY_LEFT:
	tranx -= 0.1;
	break;
    case GLUT_KEY_RIGHT:
	tranx += 0.1;
	break;
    case GLUT_KEY_PAGE_UP:
	tranz += 0.1;
	break;
    case GLUT_KEY_PAGE_DOWN:
	tranz -= 0.1;
	break;
    case GLUT_KEY_HOME:
        wResetRotation ();
	break;
    default:
	return;
    }
    wPostRedisplay ();
}

void
wCreateMenus (void) {
    /* Modus-Submenue */
    menIdMainSubModus = glutCreateMenu (wSubMenuModus);
    glutAddMenuEntry ("<1> Hauptdiagonale fixiert", 1);
    glutAddMenuEntry ("<2> Scharnierkante fixiert", 2);
    glutAddMenuEntry ("<3> Element fixiert", 3);
    glutAddMenuEntry ("<4> Mittelpunkt fixiert", 4);

    /* Achsen-Transformations-Submenue */
/*     menIdMainSubAxis = glutCreateMenu (wSubMenuAxis); */
/*     glutAddMenuEntry ("<c> keine Achsentransformation", 1); */
/*     glutAddMenuEntry ("<c> Achsentransf. y", 2); */
/*     glutAddMenuEntry ("<c> Achsentransf. y+x", 3); */

    /* Geschwindigkeit-Submenue */
    menIdMainSubSpeed = glutCreateMenu (wSubMenuSpeed);
    glutAddMenuEntry ("<+> Schneller", 1);
    glutAddMenuEntry ("<-> Langsamer", 2);

    /* Create main menu for main window */
    menIdMain = glutCreateMenu (wMainMenu);
    if (options.tork) {
        glutAddMenuEntry ("<t> Schweben aus", 1);
    }
    else {
        glutAddMenuEntry ("<t> Schweben ein", 1);
    }
    if (options.virtuell) {
        glutAddMenuEntry ("<v> Virtuelle Ecken aus", 2);
    }
    else {
        glutAddMenuEntry ("<v> Virtuelle Ecken ein", 2);
    }
    if (options.ach) {
        glutAddMenuEntry ("<a> Achsen aus", 3);
    }
    else {
        glutAddMenuEntry ("<a> Achsen ein", 3);
    }
    if (options.perspektive) {
        glutAddMenuEntry ("<p> Projektion parallel", 4);
    }
    else {
        glutAddMenuEntry ("<p> Projektion perspektivisch", 4);
    }
    if (options.lines) {
        glutAddMenuEntry ("<g> Flchen", 5);
    }
    else {
        glutAddMenuEntry ("<g> Gitter", 5);
    }
    if (options.labels) {
        glutAddMenuEntry ("<l> Labels aus", 6);
    }
    else {
        glutAddMenuEntry ("<l> Labels ein", 6);
    }
    if (options.kuboid) {
        glutAddMenuEntry ("<k> Kuboid aus", 7);
    }
    else {
        glutAddMenuEntry ("<k> Kuboid ein", 7);
    }
    if (options.oloid) {
        glutAddMenuEntry ("<o> Oloid aus", 8);
    }
    else {
        glutAddMenuEntry ("<o> Oloid ein", 8);
    }
    if (options.beide) {
        glutAddMenuEntry ("<B> Beide aus", 9);
    }
    else {
        glutAddMenuEntry ("<B> Beide ein", 9);
    }
    if (options.wuerfel) {
        glutAddMenuEntry ("<w> Wrfelgrtel aus", 10);
    }
    else {
        glutAddMenuEntry ("<w> Wrfelgrtel ein", 10);
    }
    if (options.touchline) {
        glutAddMenuEntry ("<b> Berhrungslinie aus", 11);
    }
    else {
        glutAddMenuEntry ("<b> Berhrungslinie ein", 11);
    }
    if (options.erzeugende) {
        glutAddMenuEntry ("<r> Flche der Zeitform aus", 12);
    }
    else {
        glutAddMenuEntry ("<r> Flche der Zeitform ein", 12);
    }
    if (options.endpunkte) {
        glutAddMenuEntry ("<e> Endpunkte aus", 13);
    }
    else {
        glutAddMenuEntry ("<e> Endpunkte ein", 13);
    }
    if (options.info) {
        glutAddMenuEntry ("<i> Info aus", 14);
    }
    else {
        glutAddMenuEntry ("<i> Info ein", 14);
    }
    glutAddMenuEntry ("<c> nchste Achsentransf.", 15);
    if (options.automatic) {
        glutAddMenuEntry ("<A> Automatik aus", 16);
    }
    else {
        glutAddMenuEntry ("<A> Automatik ein", 16);
    }
    if (options.diagonals) {
        glutAddMenuEntry ("<D> Diagonalen aus", 17);
    }
    else {
        glutAddMenuEntry ("<D> Diagonalen ein", 17);
    }
    if (options.automatic) {
        glutAddMenuEntry ("<M> Mittelpunkt aus", 18);
    }
    else {
        glutAddMenuEntry ("<M> Mittelpunkt ein", 18);
    }

    glutAddSubMenu ("Geschwindigkeit", menIdMainSubSpeed);
    glutAddSubMenu ("Modus", menIdMainSubModus);
/*     glutAddSubMenu ("Achsentransf.", menIdMainSubAxis); */

    glutAddMenuEntry ("<q> Ende", 19);

    glutAttachMenu (GLUT_RIGHT_BUTTON);
}

void
wSubMenuModus (int value) {
    switch (value) {
    case 1:
    case 2:
    case 3:
    case 4:
	options.mode = value;
	break;
    }
}

void
wSubMenuAxis (int value) {
    wAdvanceAxisTransform ();
}

void
wSubMenuSpeed (int value) {
    switch (value) {
    case 1:
	waittime.tv_usec /= 2;
	break;
    case 2:
	if (waittime.tv_usec > 1000000) {
	    fprintf (stderr, "Zeitintervall bereits > 1 sek, Eingabe ignoriert\n");
	    return;
	}
        waittime.tv_usec *= 2;
	if (waittime.tv_usec == 0) {waittime.tv_usec = 1;}
	break;
    }
}

void
wMainMenu(int value){

    switch(value){
    case 1:
	wToggleTorkeln ();
	break;
    case 2:
	wToggleVirtuell ();
	break;
    case 3:
	wToggleAxis ();
	break;
    case 4:
	wTogglePerspektive ();
	break;
    case 5:
	wToggleGitterFlaechen ();
	break;
    case 6:
	wToggleLabels ();
	break;
    case 7:
	wToggleKuboid ();
	break;
    case 8:
	wToggleOloid ();
	break;
    case 9:
	wToggleBeide ();
	break;
    case 10:
	wToggleWuerfelguertel ();
	break;
    case 11:
	wToggleTouchline ();
	break;
    case 12:
	wToggleErzeugende ();
	break;
    case 13:
	wToggleEndpunkte ();
	break;
    case 14:
	wToggleInfo ();
	break;
    case 15:
	wAdvanceAxisTransform ();
	break;
    case 16:
	wToggleAutomatic ();
	break;
    case 17:
	wToggleDiagonals ();
	break;
    case 18:
	wToggleCenter ();
	break;
    case 19:
	wExit ();
	break;
    }
}

void
wToggleTorkeln (void) {
      if(options.tork) {
	  glutChangeToMenuEntry(1, "<t> Schweben ein", 1);
      }
      else {
	  glutChangeToMenuEntry(1, "<t> Schweben aus", 1);
      }
      options.tork = ! options.tork;
}

void
wToggleVirtuell (void) {
      if(options.virtuell) {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken ein", 2);
      }
      else {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken aus", 2);
      }
      options.virtuell = ! options.virtuell;
}

void
wToggleAxis (void) {
      if(options.ach) {
	  glutChangeToMenuEntry(3, "<a> Achsen ein", 3);
      }
      else {
	  glutChangeToMenuEntry(3, "<a> Achsen aus", 3);
      }
      options.ach = ! options.ach;
}

void
wTogglePerspektive (void) {
      if(options.perspektive) {
	  glutChangeToMenuEntry(4, "<p> Projektion perspektivisch", 4);
      }
      else {
	  glutChangeToMenuEntry(4, "<p> Projektion parallel", 4);
      }
      options.perspektive = ! options.perspektive;
      wReshape (options.seite, options.seite);
}

void
wToggleGitterFlaechen (void) {
      if(options.lines) {
	  glutChangeToMenuEntry(5, "<g> Gitter", 5);
      }
      else {
	  glutChangeToMenuEntry(5, "<g> Flchen", 5);
      }
      options.lines = ! options.lines;
      /* polygonMode sollte erst beim Ausgeben gesetzt werden */
      if (polygonMode == GL_LINE) {
	  polygonMode = GL_FILL;
      }
      else {
	  polygonMode = GL_LINE;
      }
      wErr(glPolygonMode (GL_FRONT_AND_BACK, polygonMode));
}

void
wToggleLabels (void) {
      if(options.labels) {
	  glutChangeToMenuEntry(6, "<l> Labels ein", 6);
      }
      else {
	  glutChangeToMenuEntry(6, "<l> Labels aus", 6);
      }
      options.labels = ! options.labels;
      wCreateDisplayLists ();
}

void
wToggleKuboid (void) {
      if(options.kuboid) {
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
      }
      else {
          options.kuboid = TRUE;
	  glutChangeToMenuEntry(7, "<k> Kuboid aus", 7);
          options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
	  options.axistrans = 1; /* Achsentransformation fuer Kuboid */
	  rotx = rotz = 0;       /* in eine Ausgangsposition */
      }
      wCreateDisplayLists ();
}

void
wToggleOloid (void) {
      if(options.oloid) {
	  options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
      }
      else {
          options.oloid = TRUE;
	  glutChangeToMenuEntry(8, "<o> Oloid aus", 8);
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
	  options.axistrans = 2; /* Achsentransformation fuer Oloid */
	  rotx = rotz = 0;       /* in eine Ausgangsposition */
      }
      wCreateDisplayLists ();
}

void
wToggleBeide (void) {
      if(options.beide) {
	  options.beide = FALSE;
	  glutChangeToMenuEntry(9, "<B> Beide ein", 9);
      }
      else {
          options.beide = TRUE;
	  glutChangeToMenuEntry(9, "<B> Beide aus", 9);
      }
      wCreateDisplayLists ();
}

void
wToggleWuerfelguertel (void) {
      if(options.wuerfel) {
	  glutChangeToMenuEntry(10, "<w> Wrfelguertel ein", 10);
      }
      else {
	  glutChangeToMenuEntry(10, "<w> Wrfelguertel aus", 10);
      }
      options.wuerfel = ! options.wuerfel;
}

void
wToggleTouchline (void) {
      if(options.touchline) {
	  glutChangeToMenuEntry(11, "<b> Berhrungslinie ein", 11);
      }
      else {
	  glutChangeToMenuEntry(11, "<b> Berhrungslinie aus", 11);
      }
      options.touchline = ! options.touchline;
/*       wCreateDisplayLists (); */
}

void
wToggleErzeugende (void) {
      if(options.erzeugende) {
	  glutChangeToMenuEntry(12, "<r> Flche der Zeitform ein", 12);
      }
      else {
	  glutChangeToMenuEntry(12, "<r> Flche der Zeitform aus", 12);
      }
      options.erzeugende = ! options.erzeugende;
/*       wCreateDisplayLists (); */
}

void
wToggleEndpunkte (void) {
      if(options.endpunkte) {
	  glutChangeToMenuEntry(13, "<e> Endpunkte ein", 13);
      }
      else {
	  glutChangeToMenuEntry(13, "<e> Endpunkte aus", 13);
      }
      options.endpunkte = ! options.endpunkte;
/*       wCreateDisplayLists (); */
}

void
wAdvanceAxisTransform (void) {
      options.axistrans = (options.axistrans + 1) % 3;
      wCreateDisplayLists ();
}

void
wResetRotation () {
  static int homeposition = 0;
  /*
  ** Ansicht in eine achsiale Lage bringen
  ** dabei werden jedenfalls die Werte fuer die Schwebebewegung auf 0 gesetzt.
  ** Die Werte fuer die Drehbewegung des Bewegungssystems selbst werden der
  ** Reihe nach fuer alle 3 Achsen auf 0, dann 90 Grad gesetzt.
  */
      drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
      tranx = trany = tranz = 0.;

      switch (homeposition) {
      case 0:
	rotx = roty = rotz = 0.;
	break;
      case 1:
	rotx = 90.;
	roty = rotz = 0.;
	break;
      case 2:
	rotx = roty = 90.;
	rotz = 0.;
	break;
      case 3:
	rotx = roty = rotz = 90.;
	break;
      }
      homeposition = ++homeposition % 4;

      wCreateDisplayLists ();
}

void
wToggleInfo (void) {
      if(options.info) {
	  glutChangeToMenuEntry(14, "<i> Info ein", 14);
      }
      else {
	  glutChangeToMenuEntry(14, "<i> Info aus", 14);
      }
      glutSetWindow (winIdSub);
      if (options.info) {
          glutHideWindow();
      }
      else {
          glutShowWindow();
      }
      options.info = ! options.info;
}

void
wToggleAutomatic (void) {
      if(options.automatic) {
	  glutChangeToMenuEntry(16, "<A> Automatik ein", 16);
      }
      else {
	  glutChangeToMenuEntry(16, "<A> Automatik aus", 16);
      }
      options.automatic = ! options.automatic;
}

void
wSetImpulse (void) {
      options.impulse = TRUE;
}

void
wToggleDiagonals (void) {
      if(options.diagonals) {
	  options.diagonals = FALSE;
	  glutChangeToMenuEntry(17, "<D> Diagonalen ein", 17);
      }
      else {
          options.diagonals = TRUE;
	  glutChangeToMenuEntry(17, "<D> Diagonalen aus", 17);
      }
/*       wCreateDisplayLists (); */
}

void
wToggleCenter (void) {
      if(options.center) {
	  options.center = FALSE;
	  glutChangeToMenuEntry(18, "<M> Mittelpunkt ein", 18);
      }
      else {
          options.center = TRUE;
	  glutChangeToMenuEntry(18, "<M> Mittelpunkt aus", 18);
      }
/*       wCreateDisplayLists (); */
}

void
wToggleHalt (void) {
      halt = !halt;
}

void
wExit (void) {
      exit (1);
}
